#include <ctime>
#include <cstdio>

static void copy1(int* dst, const int* src, int n) {
  for (int i = 0; i < n; i++)
    dst[i] = src[i];
}

static void copy2(int* dst, const int* src, int n) {
  for (int i = 0; i < n%8; i++)
    dst[i] = src[i];

  for (int i = 0; i < n/8; i++) {
    int index = 8*i;
    dst[index + 0] = src[index + 0];
    dst[index + 1] = src[index + 1];
    dst[index + 2] = src[index + 2];
    dst[index + 3] = src[index + 3];
    dst[index + 4] = src[index + 4];
    dst[index + 5] = src[index + 5];
    dst[index + 6] = src[index + 6];
    dst[index + 7] = src[index + 7];
  }
}


static const int limit = 100000;
static const int n = 8000;

int main() {
  int src[n];
  int dst[n];

  time_t now = time(0);
  for (int k = 0; k < limit; k++) {
    copy1(dst, src, n);
  }
  printf("%g\n", difftime(time(0), now));

  now = time(0);
  for (int k = 0; k < limit; k++) {
    copy2(dst, src, n);
  }
  printf("%g\n", difftime(time(0), now));

  return 0;
}
