#include <ctime>
#include <cstdio>

static void copy1(int* dst, const int* src, int n) {
  for (int i = 0; i < n; i++)
    *dst++ = *src++;
}

/* Motivation: Use switch statement to jump to correct number of
 * assignments, then use enclosing do-while loop to repeat. */
static void copy2(int* dst, const int* src, int n) {
  int limit = (n + 7) / 8;
  switch (n%8) {
  case 0: do {
            *dst++ = *src++;
  case 7:   *dst++ = *src++;
  case 6:   *dst++ = *src++;
  case 5:   *dst++ = *src++;
  case 4:   *dst++ = *src++;
  case 3:   *dst++ = *src++;
  case 2:   *dst++ = *src++;
  case 1:   *dst++ = *src++;
    } while (--limit > 0);
  }
}

static const int limit = 100000;
static const int n = 8007;

int main() {
  int src[n];
  int dst[n];

  time_t now = time(0);
  for (int k = 0; k < limit; k++) {
    copy1(dst, src, n);
  }
  printf("%g\n", difftime(time(0), now));

  now = time(0);
  for (int k = 0; k < limit; k++) {
    copy2(dst, src, n);
  }
  printf("%g\n", difftime(time(0), now));

  return 0;
}
