/* union2.cc: real-life example of unions (poor man's inheritance). */
#include <cstdio>
#include <fcntl.h>

/** A process opens a file. */
struct open_event_t {
  int flags;                    /**< Flags with which path is opened. */
  mode_t mode;                  /**< Permission bits (no umask). */
};

/** A process reads a file. */
struct read_event_t {
  int fd;                       /**< File descriptor. */
  void *buf;                    /**< User-space address. */
  size_t count;                 /**< Number of bytes to be read. */
};

const int open_tag = 1;
const int read_tag = 2;

struct event_t {
  int tag;                      /**< Syscall tag. */

  /** The event. */
  union {
    struct open_event_t open;   /**< The open event. */
    struct read_event_t read;   /**< The read event. */
  } e;
};

int main() {
  event_t event;

  event.tag = open_tag;
  event.e.open.flags = 0;
  event.e.open.mode = 0;

  return 0;
}
